import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe abstrata padrão de loading
 * @abstract
 */
class LoadingDefault {
    /**
     * Execução do loading
     * callback
     * args
     * @template Z
     * @param {?} callback
     * @param {...?} args
     * @return {?}
     */
    executeLoading(callback, ...args) {
        this.showLoading();
        /** @type {?} */
        const fn = (/** @type {?} */ (callback(...args)));
        if (fn instanceof Promise) {
            fn
                .then((/**
             * @param {?} data
             * @return {?}
             */
            (data) => { this.hideLoading(); return data; }))
                .catch((/**
             * @param {?} error
             * @return {?}
             */
            (error) => { this.hideLoading(); return error; }));
        }
        else if (fn instanceof Observable) {
            /** @type {?} */
            const obs = (/** @type {?} */ (fn));
            obs.pipe(map((/**
             * @param {?} data
             * @return {?}
             */
            (data) => { this.hideLoading(); return data; })))
                .subscribe();
        }
        else {
            this.hideLoading();
        }
        return fn;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const ShowMessageLinkActionType = {
    No: 0,
    LinkNewTab: 1,
    Method: 2,
};
ShowMessageLinkActionType[ShowMessageLinkActionType.No] = 'No';
ShowMessageLinkActionType[ShowMessageLinkActionType.LinkNewTab] = 'LinkNewTab';
ShowMessageLinkActionType[ShowMessageLinkActionType.Method] = 'Method';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const ShowMessageType = {
    NotificationSuccess: 0,
    NotificationInformation: 1,
    NotificationError: 2,
    NotificationWarning: 3,
    DialogConfirmation: 4,
    DialogAlert: 5,
};
ShowMessageType[ShowMessageType.NotificationSuccess] = 'NotificationSuccess';
ShowMessageType[ShowMessageType.NotificationInformation] = 'NotificationInformation';
ShowMessageType[ShowMessageType.NotificationError] = 'NotificationError';
ShowMessageType[ShowMessageType.NotificationWarning] = 'NotificationWarning';
ShowMessageType[ShowMessageType.DialogConfirmation] = 'DialogConfirmation';
ShowMessageType[ShowMessageType.DialogAlert] = 'DialogAlert';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe com as opções de apresentação de mensagem
 */
class ShowMessageOptions {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const TotvsMessageType = {
    success: 0,
    warning: 1,
    error: 2,
    information: 3,
};
TotvsMessageType[TotvsMessageType.success] = 'success';
TotvsMessageType[TotvsMessageType.warning] = 'warning';
TotvsMessageType[TotvsMessageType.error] = 'error';
TotvsMessageType[TotvsMessageType.information] = 'information';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const MessageType = {
    ERROR: 1,
    WARNING: 2,
    SUCESS: 4,
    NOTIFICATION: 8,
    EXTERNAL: 16,
    CRITICAL: 32,
};
MessageType[MessageType.ERROR] = 'ERROR';
MessageType[MessageType.WARNING] = 'WARNING';
MessageType[MessageType.SUCESS] = 'SUCESS';
MessageType[MessageType.NOTIFICATION] = 'NOTIFICATION';
MessageType[MessageType.EXTERNAL] = 'EXTERNAL';
MessageType[MessageType.CRITICAL] = 'CRITICAL';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe utilitarios de mensagem
 */
class MessageUtils {
    /**
     * Retorna o que foi passado formatado.
     * @param {?=} data
     * @return {?}
     */
    static formattable(data) {
        return data && data.length !== 0;
    }
    /**
     * Converte de TotvsMessageType para MessageType
     * @param {?} totvsMessageType
     * @return {?}
     */
    static messageTypeFrom(totvsMessageType) {
        /** @type {?} */
        let type;
        switch (TotvsMessageType[totvsMessageType]) {
            case TotvsMessageType.error:
                type = MessageType.ERROR;
                break;
            case TotvsMessageType.information:
                type = MessageType.NOTIFICATION;
                break;
            case TotvsMessageType.success:
                type = MessageType.SUCESS;
                break;
            case TotvsMessageType.warning:
                type = MessageType.WARNING;
                break;
            default:
                type = MessageType.EXTERNAL;
        }
        return type;
    }
    /**
     * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
     * @param {?} message
     * @return {?}
     */
    static showMessageTypeFromTotvsMessage(message) {
        /** @type {?} */
        let messageType;
        switch (message.type) {
            default:
            case 'error':
                messageType = ShowMessageType.DialogAlert;
                break;
            case 'information':
                messageType = ShowMessageType.NotificationInformation;
                break;
            case 'warning':
                messageType = ShowMessageType.NotificationInformation;
                break;
            case 'success':
                messageType = ShowMessageType.NotificationInformation;
                break;
        }
        return messageType;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe de texto da mensagem
 */
class TextMessage {
    /**
     * Construtor da classe
     * msg
     * @param {?} msg
     */
    constructor(msg) {
        this.text = msg.text;
        this.detailText = msg.detailText;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe específica para tratar erros críticos do sistema
 */
class CriticalError extends Error {
    /**
     * Método construtor que inicializa a classe
     * internalError
     * @param {?} internalError
     * @param {?=} objectData
     */
    constructor(internalError, objectData) {
        super(internalError.toString());
        console.error(internalError);
        if (objectData) {
            console.log(JSON.stringify(objectData));
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe base de mensagens
 */
class BaseMessage {
    /**
     * Método construtor da classe
     * msg
     * @param {?} msg
     */
    constructor(msg) {
        /**
         * Tipo da mensagem que carrega
         */
        this._messageType = ShowMessageType.NotificationSuccess;
        this.literal = msg.literal;
        if (msg.detail) {
            this.detail = msg.detail;
        }
    }
    /**
     * Tipo da mensagem que carrega
     * @return {?}
     */
    get messageType() {
        return this._messageType;
    }
    /**
     * Builder para setar o tipo de mensagem
     * @param {?} messageType
     * @return {?}
     */
    withMessageType(messageType) {
        this._messageType = messageType;
        return this;
    }
    /**
     * Método que seta a literal
     * @param {?} literal
     * @return {?}
     */
    set literal(literal) {
        try {
            this.isLiteralValid(literal);
        }
        catch (error) {
            throw error;
        }
        this._literal = literal;
    }
    /**
     * Método que busca a literal
     * @return {?}
     */
    get literal() {
        return this._literal;
    }
    /**
     * Método que seta o detalhe da literal
     * @param {?} detail
     * @return {?}
     */
    set detail(detail) {
        try {
            this.isLiteralValid(detail);
        }
        catch (error) {
            throw error;
        }
        this._detail = detail;
    }
    /**
     * Método que busca o detalhe da literal
     * @return {?}
     */
    get detail() {
        return this._detail;
    }
    /**
     * Facilita a adição de dados para formatação da literal
     * @template THIS
     * @this {THIS}
     * @param {?} data
     * @return {THIS}
     */
    withLiteralData(data) {
        (/** @type {?} */ (this))._literalData = data;
        return (/** @type {?} */ (this));
    }
    /**
     * Método que busca a literal
     * @return {?}
     */
    get literalData() {
        return this._literalData;
    }
    /**
     * Facilita a adição de dados para formatação do detalhe da literal
     * @template THIS
     * @this {THIS}
     * @param {?} data
     * @return {THIS}
     */
    withDetailData(data) {
        (/** @type {?} */ (this))._detailData = data;
        return (/** @type {?} */ (this));
    }
    /**
     * Método que busca o detalhe da literal
     * @return {?}
     */
    get detailData() {
        return this._detailData;
    }
    /**
     * Método que busca a literal formatada
     * @return {?}
     */
    get literalFormattable() {
        return MessageUtils.formattable(this._literalData);
    }
    /**
     * Método que busca o detalhe da literal formatado
     * @return {?}
     */
    get detailFormattable() {
        return MessageUtils.formattable(this._detailData);
    }
    /**
     * Método de internacionalização de mensagem
     * @param {?} i18n
     * @return {?}
     */
    messageI18n(i18n) {
        return i18n.text(this);
    }
    /**
     * Método que verifica se literal é válida
     * @protected
     * @param {?} literal
     * @return {?}
     */
    isLiteralValid(literal) {
        if (literal === undefined) {
            throw new CriticalError('Literal não pode ser undefined.');
        }
        else if (literal.length === 0) {
            throw new CriticalError('Literal não pode ser uma string vazia.');
        }
        else if (literal.search(' ') !== -1) {
            throw new CriticalError('Literal não pode conter espaços.');
        }
        try {
        }
        catch (erro) {
            throw new CriticalError(erro);
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe base de internacionalização
 *
 * @export
 * @abstract
 */
class I18nBaseService {
    /**
     * Construtor da classe
     * literalLoader
     * @param {?} literalLoader
     */
    constructor(literalLoader) {
        this.literalLoader = literalLoader;
        /**
         * Opções de internacionalização
         */
        this.options = { language: '', url: '' };
    }
    /**
     * Método responsável por setar os atributos definidos da internacionalização context, language, url
     * @param {?} options
     * @return {?}
     */
    updateOptions(options) {
        if (options === undefined) {
            throw new CriticalError('options não definido.', this);
        }
        try {
            Object.assign(this.options, options);
            return this.literalLoader
                .updateOptions(this.options)
                .pipe(map((/**
             * @param {?} res
             * @return {?}
             */
            res => (this.literals = res))));
        }
        catch (error) {
            throw new CriticalError(error);
        }
    }
    /**
     * Método responsável por setar o formato do valor
     * @param {?} data
     * @param {?} text
     * @return {?}
     */
    format(data, text) {
        if (MessageUtils.formattable(data)) {
            data.forEach((/**
             * @param {?} d
             * @param {?} i
             * @return {?}
             */
            (d, i) => {
                text = text.replace(`{${i}}`, d);
            }));
            return text;
        }
        else {
            return text;
        }
    }
    /**
     * Método responsável por buscar e setar a literal do detalhe da mensagem
     * @param {?} baseMsg
     * @return {?}
     */
    text(baseMsg) {
        /** @type {?} */
        let msg;
        try {
            /** @type {?} */
            let detail = '';
            if (baseMsg.detail) {
                detail = this.format(baseMsg.detailData, this.literals[baseMsg.detail]);
            }
            msg = new TextMessage({
                text: this.format(baseMsg.literalData, this.literals[baseMsg.literal]),
                detailText: detail
            });
        }
        catch (error) {
            // tslint:disable-next-line:max-line-length
            throw new CriticalError(`Literais não encontradas '${baseMsg.literal}'/'${baseMsg.detail}'`);
        }
        return msg;
    }
    /**
     * Método responsável por retornar se tem literal
     * @param {?} literal
     * @return {?}
     */
    hasLiteral(literal) {
        try {
            return this.literals[literal] !== undefined;
        }
        catch (error) {
            console.log(error);
            return false;
        }
    }
    /**
     * Método responsável por retornar as opções de linguagem
     * @return {?}
     */
    getLanguage() {
        return this.options.language;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { LoadingDefault, I18nBaseService, MessageUtils, TextMessage, MessageType, CriticalError, BaseMessage, ShowMessageLinkActionType, ShowMessageType, ShowMessageOptions, TotvsMessageType };

//# sourceMappingURL=base-foundation.js.map