import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { __spread, __extends } from 'tslib';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe abstrata padrão de loading
 * @abstract
 */
var  /**
 * Classe abstrata padrão de loading
 * @abstract
 */
LoadingDefault = /** @class */ (function () {
    function LoadingDefault() {
    }
    /**
     * Execução do loading
     * callback
     * args
     */
    /**
     * Execução do loading
     * callback
     * args
     * @template Z
     * @param {?} callback
     * @param {...?} args
     * @return {?}
     */
    LoadingDefault.prototype.executeLoading = /**
     * Execução do loading
     * callback
     * args
     * @template Z
     * @param {?} callback
     * @param {...?} args
     * @return {?}
     */
    function (callback) {
        var _this = this;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        this.showLoading();
        /** @type {?} */
        var fn = (/** @type {?} */ (callback.apply(void 0, __spread(args))));
        if (fn instanceof Promise) {
            fn
                .then((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { _this.hideLoading(); return data; }))
                .catch((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { _this.hideLoading(); return error; }));
        }
        else if (fn instanceof Observable) {
            /** @type {?} */
            var obs = (/** @type {?} */ (fn));
            obs.pipe(map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { _this.hideLoading(); return data; })))
                .subscribe();
        }
        else {
            this.hideLoading();
        }
        return fn;
    };
    return LoadingDefault;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var ShowMessageLinkActionType = {
    No: 0,
    LinkNewTab: 1,
    Method: 2,
};
ShowMessageLinkActionType[ShowMessageLinkActionType.No] = 'No';
ShowMessageLinkActionType[ShowMessageLinkActionType.LinkNewTab] = 'LinkNewTab';
ShowMessageLinkActionType[ShowMessageLinkActionType.Method] = 'Method';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var ShowMessageType = {
    NotificationSuccess: 0,
    NotificationInformation: 1,
    NotificationError: 2,
    NotificationWarning: 3,
    DialogConfirmation: 4,
    DialogAlert: 5,
};
ShowMessageType[ShowMessageType.NotificationSuccess] = 'NotificationSuccess';
ShowMessageType[ShowMessageType.NotificationInformation] = 'NotificationInformation';
ShowMessageType[ShowMessageType.NotificationError] = 'NotificationError';
ShowMessageType[ShowMessageType.NotificationWarning] = 'NotificationWarning';
ShowMessageType[ShowMessageType.DialogConfirmation] = 'DialogConfirmation';
ShowMessageType[ShowMessageType.DialogAlert] = 'DialogAlert';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe com as opções de apresentação de mensagem
 */
var  /**
 * Classe com as opções de apresentação de mensagem
 */
ShowMessageOptions = /** @class */ (function () {
    function ShowMessageOptions() {
    }
    return ShowMessageOptions;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var TotvsMessageType = {
    success: 0,
    warning: 1,
    error: 2,
    information: 3,
};
TotvsMessageType[TotvsMessageType.success] = 'success';
TotvsMessageType[TotvsMessageType.warning] = 'warning';
TotvsMessageType[TotvsMessageType.error] = 'error';
TotvsMessageType[TotvsMessageType.information] = 'information';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var MessageType = {
    ERROR: 1,
    WARNING: 2,
    SUCESS: 4,
    NOTIFICATION: 8,
    EXTERNAL: 16,
    CRITICAL: 32,
};
MessageType[MessageType.ERROR] = 'ERROR';
MessageType[MessageType.WARNING] = 'WARNING';
MessageType[MessageType.SUCESS] = 'SUCESS';
MessageType[MessageType.NOTIFICATION] = 'NOTIFICATION';
MessageType[MessageType.EXTERNAL] = 'EXTERNAL';
MessageType[MessageType.CRITICAL] = 'CRITICAL';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe utilitarios de mensagem
 */
var  /**
 * Classe utilitarios de mensagem
 */
MessageUtils = /** @class */ (function () {
    function MessageUtils() {
    }
    /**
     * Retorna o que foi passado formatado.
     */
    /**
     * Retorna o que foi passado formatado.
     * @param {?=} data
     * @return {?}
     */
    MessageUtils.formattable = /**
     * Retorna o que foi passado formatado.
     * @param {?=} data
     * @return {?}
     */
    function (data) {
        return data && data.length !== 0;
    };
    /**
     * Converte de TotvsMessageType para MessageType
     */
    /**
     * Converte de TotvsMessageType para MessageType
     * @param {?} totvsMessageType
     * @return {?}
     */
    MessageUtils.messageTypeFrom = /**
     * Converte de TotvsMessageType para MessageType
     * @param {?} totvsMessageType
     * @return {?}
     */
    function (totvsMessageType) {
        /** @type {?} */
        var type;
        switch (TotvsMessageType[totvsMessageType]) {
            case TotvsMessageType.error:
                type = MessageType.ERROR;
                break;
            case TotvsMessageType.information:
                type = MessageType.NOTIFICATION;
                break;
            case TotvsMessageType.success:
                type = MessageType.SUCESS;
                break;
            case TotvsMessageType.warning:
                type = MessageType.WARNING;
                break;
            default:
                type = MessageType.EXTERNAL;
        }
        return type;
    };
    /**
     * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
     */
    /**
     * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
     * @param {?} message
     * @return {?}
     */
    MessageUtils.showMessageTypeFromTotvsMessage = /**
     * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
     * @param {?} message
     * @return {?}
     */
    function (message) {
        /** @type {?} */
        var messageType;
        switch (message.type) {
            default:
            case 'error':
                messageType = ShowMessageType.DialogAlert;
                break;
            case 'information':
                messageType = ShowMessageType.NotificationInformation;
                break;
            case 'warning':
                messageType = ShowMessageType.NotificationInformation;
                break;
            case 'success':
                messageType = ShowMessageType.NotificationInformation;
                break;
        }
        return messageType;
    };
    return MessageUtils;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe de texto da mensagem
 */
var  /**
 * Classe de texto da mensagem
 */
TextMessage = /** @class */ (function () {
    /**
     * Construtor da classe
     * msg
     */
    function TextMessage(msg) {
        this.text = msg.text;
        this.detailText = msg.detailText;
    }
    return TextMessage;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe específica para tratar erros críticos do sistema
 */
var  /**
 * Classe específica para tratar erros críticos do sistema
 */
CriticalError = /** @class */ (function (_super) {
    __extends(CriticalError, _super);
    /**
     * Método construtor que inicializa a classe
     * internalError
     */
    function CriticalError(internalError, objectData) {
        var _this = _super.call(this, internalError.toString()) || this;
        console.error(internalError);
        if (objectData) {
            console.log(JSON.stringify(objectData));
        }
        return _this;
    }
    return CriticalError;
}(Error));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe base de mensagens
 */
var  /**
 * Classe base de mensagens
 */
BaseMessage = /** @class */ (function () {
    /**
     * Método construtor da classe
     * msg
     */
    function BaseMessage(msg) {
        /**
         * Tipo da mensagem que carrega
         */
        this._messageType = ShowMessageType.NotificationSuccess;
        this.literal = msg.literal;
        if (msg.detail) {
            this.detail = msg.detail;
        }
    }
    Object.defineProperty(BaseMessage.prototype, "messageType", {
        /** Tipo da mensagem que carrega */
        get: /**
         * Tipo da mensagem que carrega
         * @return {?}
         */
        function () {
            return this._messageType;
        },
        enumerable: true,
        configurable: true
    });
    /** Builder para setar o tipo de mensagem */
    /**
     * Builder para setar o tipo de mensagem
     * @param {?} messageType
     * @return {?}
     */
    BaseMessage.prototype.withMessageType = /**
     * Builder para setar o tipo de mensagem
     * @param {?} messageType
     * @return {?}
     */
    function (messageType) {
        this._messageType = messageType;
        return this;
    };
    Object.defineProperty(BaseMessage.prototype, "literal", {
        /**
         * Método que busca a literal
         */
        get: /**
         * Método que busca a literal
         * @return {?}
         */
        function () {
            return this._literal;
        },
        /**
         * Método que seta a literal
         */
        set: /**
         * Método que seta a literal
         * @param {?} literal
         * @return {?}
         */
        function (literal) {
            try {
                this.isLiteralValid(literal);
            }
            catch (error) {
                throw error;
            }
            this._literal = literal;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseMessage.prototype, "detail", {
        /**
         * Método que busca o detalhe da literal
         */
        get: /**
         * Método que busca o detalhe da literal
         * @return {?}
         */
        function () {
            return this._detail;
        },
        /**
         * Método que seta o detalhe da literal
         */
        set: /**
         * Método que seta o detalhe da literal
         * @param {?} detail
         * @return {?}
         */
        function (detail) {
            try {
                this.isLiteralValid(detail);
            }
            catch (error) {
                throw error;
            }
            this._detail = detail;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Facilita a adição de dados para formatação da literal
     */
    /**
     * Facilita a adição de dados para formatação da literal
     * @template THIS
     * @this {THIS}
     * @param {?} data
     * @return {THIS}
     */
    BaseMessage.prototype.withLiteralData = /**
     * Facilita a adição de dados para formatação da literal
     * @template THIS
     * @this {THIS}
     * @param {?} data
     * @return {THIS}
     */
    function (data) {
        (/** @type {?} */ (this))._literalData = data;
        return (/** @type {?} */ (this));
    };
    Object.defineProperty(BaseMessage.prototype, "literalData", {
        /**
         * Método que busca a literal
         */
        get: /**
         * Método que busca a literal
         * @return {?}
         */
        function () {
            return this._literalData;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Facilita a adição de dados para formatação do detalhe da literal
     */
    /**
     * Facilita a adição de dados para formatação do detalhe da literal
     * @template THIS
     * @this {THIS}
     * @param {?} data
     * @return {THIS}
     */
    BaseMessage.prototype.withDetailData = /**
     * Facilita a adição de dados para formatação do detalhe da literal
     * @template THIS
     * @this {THIS}
     * @param {?} data
     * @return {THIS}
     */
    function (data) {
        (/** @type {?} */ (this))._detailData = data;
        return (/** @type {?} */ (this));
    };
    Object.defineProperty(BaseMessage.prototype, "detailData", {
        /**
         * Método que busca o detalhe da literal
         */
        get: /**
         * Método que busca o detalhe da literal
         * @return {?}
         */
        function () {
            return this._detailData;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseMessage.prototype, "literalFormattable", {
        /**
         * Método que busca a literal formatada
         */
        get: /**
         * Método que busca a literal formatada
         * @return {?}
         */
        function () {
            return MessageUtils.formattable(this._literalData);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseMessage.prototype, "detailFormattable", {
        /**
         * Método que busca o detalhe da literal formatado
         */
        get: /**
         * Método que busca o detalhe da literal formatado
         * @return {?}
         */
        function () {
            return MessageUtils.formattable(this._detailData);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Método de internacionalização de mensagem
     */
    /**
     * Método de internacionalização de mensagem
     * @param {?} i18n
     * @return {?}
     */
    BaseMessage.prototype.messageI18n = /**
     * Método de internacionalização de mensagem
     * @param {?} i18n
     * @return {?}
     */
    function (i18n) {
        return i18n.text(this);
    };
    /**
     * Método que verifica se literal é válida
     */
    /**
     * Método que verifica se literal é válida
     * @protected
     * @param {?} literal
     * @return {?}
     */
    BaseMessage.prototype.isLiteralValid = /**
     * Método que verifica se literal é válida
     * @protected
     * @param {?} literal
     * @return {?}
     */
    function (literal) {
        if (literal === undefined) {
            throw new CriticalError('Literal não pode ser undefined.');
        }
        else if (literal.length === 0) {
            throw new CriticalError('Literal não pode ser uma string vazia.');
        }
        else if (literal.search(' ') !== -1) {
            throw new CriticalError('Literal não pode conter espaços.');
        }
        try {
        }
        catch (erro) {
            throw new CriticalError(erro);
        }
    };
    return BaseMessage;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe base de internacionalização
 *
 * @export
 * @abstract
 */
var  /**
 * Classe base de internacionalização
 *
 * @export
 * @abstract
 */
I18nBaseService = /** @class */ (function () {
    /**
     * Construtor da classe
     * literalLoader
     */
    function I18nBaseService(literalLoader) {
        this.literalLoader = literalLoader;
        /**
         * Opções de internacionalização
         */
        this.options = { language: '', url: '' };
    }
    /**
     * Método responsável por setar os atributos definidos da internacionalização context, language, url
     */
    /**
     * Método responsável por setar os atributos definidos da internacionalização context, language, url
     * @param {?} options
     * @return {?}
     */
    I18nBaseService.prototype.updateOptions = /**
     * Método responsável por setar os atributos definidos da internacionalização context, language, url
     * @param {?} options
     * @return {?}
     */
    function (options) {
        var _this = this;
        if (options === undefined) {
            throw new CriticalError('options não definido.', this);
        }
        try {
            Object.assign(this.options, options);
            return this.literalLoader
                .updateOptions(this.options)
                .pipe(map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return (_this.literals = res); })));
        }
        catch (error) {
            throw new CriticalError(error);
        }
    };
    /**
     * Método responsável por setar o formato do valor
     */
    /**
     * Método responsável por setar o formato do valor
     * @param {?} data
     * @param {?} text
     * @return {?}
     */
    I18nBaseService.prototype.format = /**
     * Método responsável por setar o formato do valor
     * @param {?} data
     * @param {?} text
     * @return {?}
     */
    function (data, text) {
        if (MessageUtils.formattable(data)) {
            data.forEach((/**
             * @param {?} d
             * @param {?} i
             * @return {?}
             */
            function (d, i) {
                text = text.replace("{" + i + "}", d);
            }));
            return text;
        }
        else {
            return text;
        }
    };
    /**
     * Método responsável por buscar e setar a literal do detalhe da mensagem
     */
    /**
     * Método responsável por buscar e setar a literal do detalhe da mensagem
     * @param {?} baseMsg
     * @return {?}
     */
    I18nBaseService.prototype.text = /**
     * Método responsável por buscar e setar a literal do detalhe da mensagem
     * @param {?} baseMsg
     * @return {?}
     */
    function (baseMsg) {
        /** @type {?} */
        var msg;
        try {
            /** @type {?} */
            var detail = '';
            if (baseMsg.detail) {
                detail = this.format(baseMsg.detailData, this.literals[baseMsg.detail]);
            }
            msg = new TextMessage({
                text: this.format(baseMsg.literalData, this.literals[baseMsg.literal]),
                detailText: detail
            });
        }
        catch (error) {
            // tslint:disable-next-line:max-line-length
            throw new CriticalError("Literais n\u00E3o encontradas '" + baseMsg.literal + "'/'" + baseMsg.detail + "'");
        }
        return msg;
    };
    /**
     * Método responsável por retornar se tem literal
     */
    /**
     * Método responsável por retornar se tem literal
     * @param {?} literal
     * @return {?}
     */
    I18nBaseService.prototype.hasLiteral = /**
     * Método responsável por retornar se tem literal
     * @param {?} literal
     * @return {?}
     */
    function (literal) {
        try {
            return this.literals[literal] !== undefined;
        }
        catch (error) {
            console.log(error);
            return false;
        }
    };
    /**
     * Método responsável por retornar as opções de linguagem
     */
    /**
     * Método responsável por retornar as opções de linguagem
     * @return {?}
     */
    I18nBaseService.prototype.getLanguage = /**
     * Método responsável por retornar as opções de linguagem
     * @return {?}
     */
    function () {
        return this.options.language;
    };
    return I18nBaseService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { LoadingDefault, I18nBaseService, MessageUtils, TextMessage, MessageType, CriticalError, BaseMessage, ShowMessageLinkActionType, ShowMessageType, ShowMessageOptions, TotvsMessageType };

//# sourceMappingURL=base-foundation.js.map